Skip to content
Start here

Upload a schema

client.schemaValidation.schemas.create(SchemaCreateParams { zone_id, kind, name, 2 more } params, RequestOptionsoptions?): PublicSchema { created_at, kind, name, 3 more }
POST/zones/{zone_id}/schema_validation/schemas

Uploads a new OpenAPI schema for API Shield schema validation. The schema defines expected request/response formats for API endpoints.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Account API GatewayDomain API Gateway
ParametersExpand Collapse
params: SchemaCreateParams { zone_id, kind, name, 2 more }
zone_id: string

Path param: Identifier.

maxLength32
kind: "openapi_v3"

Body param: The kind of the schema

name: string

Body param: A human-readable name for the schema

source: string

Body param: The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

validation_enabled: boolean

Body param: An indicator if this schema is enabled

ReturnsExpand Collapse
PublicSchema { created_at, kind, name, 3 more }

A schema used in schema validation

created_at: string
formatdate-time
kind: "openapi_v3"

The kind of the schema

name: string

A human-readable name for the schema

schema_id: string

A unique identifier of this schema

maxLength36
minLength36
formatuuid
source: string

The raw schema, e.g., the OpenAPI schema, either as JSON or YAML

validation_enabled?: boolean

An indicator if this schema is enabled

Upload a schema

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const publicSchema = await client.schemaValidation.schemas.create({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  kind: 'openapi_v3',
  name: 'petstore schema',
  source: '<schema file contents>',
  validation_enabled: true,
});

console.log(publicSchema.schema_id);
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "locations": [
          ".paths[\"/user/{username}\"].put"
        ],
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "created_at": "2014-01-01T05:20:00.12345Z",
    "kind": "openapi_v3",
    "name": "petstore schema",
    "schema_id": "f174e90a-fafe-4643-bbbc-4a0ed4fc8415",
    "source": "<schema file contents>",
    "validation_enabled": true
  },
  "success": true
}